local function dbg(text)
  --[===[@debug@
  DEFAULT_CHAT_FRAME:AddMessage("|cff2476ffDebugWorkWork:|r " .. text)
  --@end-debug@]===]
end

local function say(text)
  DEFAULT_CHAT_FRAME:AddMessage("|cff2476ffWorkWork:|r " .. text)
end

local WorkWork, _ = ...
local Garrison = C_Garrison
WorkWork = CreateFrame("Frame")
WorkWork.Events = {}
WorkWork:RegisterEvent("GARRISON_ARCHITECT_OPENED")
WorkWork:RegisterEvent("GARRISON_ARCHITECT_CLOSED")
WorkWork:SetScript("OnEvent",function( self, event, ...) 
  self.Events[event](self, ...)
end)
WorkWork.Events["GARRISON_ARCHITECT_OPENED"] = function( self, ... ) 
  self:RegisterEvent("GARRISON_LANDINGPAGE_SHIPMENTS")
end
WorkWork.Events["GARRISON_LANDINGPAGE_SHIPMENTS"] = function( self, ... ) 
  self:SmackPeons()
end
WorkWork.Events["GARRISON_ARCHITECT_CLOSED"] = function( self, ... ) 
  self:UnregisterEvent("GARRISON_LANDINGPAGE_SHIPMENTS")
end

WorkWork.buildings = {}
WorkWork.followers = {}
WorkWork.followersList = {}

-- C_Garrison.AssignFollowerToBuilding(GarrisonBuildingFrame.selectedBuilding.plotID, self.info.followerID);
-- C_Garrison.GetBuildings() to get a table of BuildingID <=> PlotID
function WorkWork:GoToWork( plot, follower )
  -- Check if Follower is available
  if Garrison.GetFollowerStatus(follower) then 
    return 
  end
  Garrison.AssignFollowerToBuilding( plot, follower ) 
end


function WorkWork:GoToSleep( plot )
  Garrison.RemoveFollowerFromBuilding( plot ) 
end
WorkWork.SortFollowers = GarrisonFollowerList_SortFollowers
function WorkWork:SmackPeons()
  self.buildings = Garrison.GetBuildings()
  local last 
  if #self.buildings > 0 then
    for i = 1, #self.buildings do
      self.followers = Garrison.GetPossibleFollowersForBuilding(self.buildings[i].plotID);
      if (#self.followers > 0) then
        self.SortFollowers(self)
        --dbg(self.followers[1].name .. " (" ..self.followers[1].followerID..") => " ..self.buildings[i].texPrefix .." (" ..self.buildings[i].plotID..")")
        self:GoToWork(self.buildings[i].plotID, self.followers[1].followerID)
        last = i
      end
    end
    if Garrison.GetFollowerInfoForBuilding( self.buildings[last].plotID ) then
      self:UnregisterEvent("GARRISON_LANDINGPAGE_SHIPMENTS")
    end
  end
end

function WorkWork:SingLullaby()
  self.buildings = Garrison.GetBuildings()
  if #self.buildings > 0 then
    for i = 1, #self.buildings do
      WorkWork:GoToSleep( self.buildings[i].plotID )
    end
  end
end



dbg("loaded")